include (jslib_dir);

include (jslib_fileutils);

include (jslib_dirutils);

include (jslib_file);



// http://lxr.mozilla.org/seamonkey/source/xpcom/io/nsDirectoryServiceDefs.h

// http://lxr.mozilla.org/seamonkey/source/xpcom/io/nsAppDirectoryServiceDefs.h

// http://www.mozdev.org/notes/transition.html



// Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties).get("Home",Components.interfaces.nsIFile).path



//     * user_pref("javascript.options.strict", true);

//     * user_pref("javascript.options.showInConsole", true);





function about()

{

  alert("MozImage 0.0.1");

}



function prior()

{

  var fileListBox = document.getElementById("filelistbox");

  var selectedIndex = fileListBox.selectedIndex;

  if (selectedIndex >= 1)

    fileListBox.selectedIndex = selectedIndex - 1;

  else

    fileListBox.selectedIndex =  fileListBox.getRowCount() - 1;

  fileListBox.ensureIndexIsVisible ( fileListBox.selectedIndex );

}



function next()

{

  var fileListBox = document.getElementById("filelistbox");

  var selectedIndex = fileListBox.selectedIndex;

  if (selectedIndex >= -1 && selectedIndex < fileListBox.getRowCount() - 1)

    fileListBox.selectedIndex = selectedIndex + 1;

  else

    fileListBox.selectedIndex = 0;

  fileListBox.ensureIndexIsVisible ( fileListBox.selectedIndex );

}



function exit()

{

  window.close();

}



function getMainDir(event)

{

  var dirUtils = new DirUtils();

  fillListBox(dirUtils.getCurProcDir());

}



function up()

{

  var fullpath = document.getElementById("fullpath");

  var fileUtil = new FileUtils();

  if (fullpath.value)

  {

    var aPath = fullpath.value;

    var file = new File(aPath);

    var aParent = file.parent.path;

    fillListBox(aParent);

  }

}





function empty_list()

{

  var dirlistbox = document.getElementById("dirlistbox");

  var filelistbox = document.getElementById("filelistbox");

  var item;

  var i;



  i = dirlistbox.getRowCount();

  while (i > 0)

  {

    i--;

    item = dirlistbox.getItemAtIndex(i);

    dirlistbox.removeChild(item);

  }

  i = filelistbox.getRowCount();

  while (i > 0)

  {

    i--;

    item = filelistbox.getItemAtIndex(i);

    filelistbox.removeChild(item);

  }



}



function go(event)

{

  var fullpath = document.getElementById("fullpath");

  fillListBox(fullpath.value);

}



function change_dir(event)

{

  var selectedItem = event.target.selectedItem;

  var basepath = document.getElementById("fullpath");

  var path = selectedItem.getAttribute("label");

  var fileUtil = new FileUtils();



  fillListBox(fileUtil.append(basepath.value, path));

}



function change_file(event)

{

  var selectedItem = event.target.selectedItem;

  var mainimage = document.getElementById("mainimage");

  var basepath = document.getElementById("fullpath");

  var fileUtil = new FileUtils();

  

  mainimage.src = 'file:///' + fileUtil.append(basepath.value, selectedItem.label);

}



function fillListBox(adir)

{

  var dirlistbox = document.getElementById("dirlistbox");

  var filelistbox = document.getElementById("filelistbox");

  var d = new Dir(adir);

  var dirList = d.readDir();

  var fullpath = document.getElementById("fullpath");



  var dirs = new Array();

  var files = new Array();

  

  empty_list();

  fullpath.value = adir;





  for (var i = 0 ; i < dirList.length ; i++) 

    dirList[i].isDir() ?  dirs.push(dirList[i]) : files.push(dirList[i]);



  dirs.sort();

  files.sort();



  dirList = new Array();



  for (i=0;i<dirs.length;i++)

    dirlistbox.appendItem(dirs[i].leaf, '');



  for (i=0;i<files.length;i++)

    filelistbox.appendItem(files[i].leaf, '');

}

